/*
 Плавный розжиг галогенных фар ближнего света
   с функцией ДХО в пол накала.
   
 При подаче питания плавно нарастает ШИМ от 0 до 255 при 
   разомкнутых контактах ДХО, при замкнутых контактах от 0 до 150.
 Также плавно увеличивается и уменьшается скважность при включении и выключении
    ДХО в процессе работы от 150 до 255 и обратно.
 ***************************  
 Автор: Yuhan
 Сайт: https://моделка.рф ( https://xn--80ahduedo.xn--p1ai/regulyator_skorosti_ventilyatora_videokarti.html )
 Машина на Drive2: https://www.drive2.ru/r/subaru/legacy/1029139/
 ПО: Arduino IDE 
 МК: ATtini13A
       21 фефраля 2021г.
---------------------------
 Фьюзы ATtini13A не трогаем, стандартные 0x6A 0xFF
 Частота ШИМ - 4.5кГц
 Розжиг от 0 до 100%, 2.5 секунды.
*/


byte E1=0;  // Управление яркостью – подключение к 1 выходу
unsigned long StartTimer; // счетчик время для плавного пуска
int StartTimeStep=8;    // Интервал изменения яркость, в мс
int StartPowerStep=1;   // Один шаг изменения мощности двигателя
unsigned char Pw;   // Мощность ламп
int button_pin = 2;     // пин кнопки

void setup()
{
Pw=0; // Начальная яркость - 0

}



void loop()
{
if (digitalRead(button_pin) == LOW) {
if (Pw<150)   // Увеличиваем яркость до тех пор, пока не достигнем максимума
if ((millis()-StartTimer)>= StartTimeStep)  // Проверяем, сколько прошло с последнего изменения яркости
// если больше, чем заданный интервал – увеличим яркость еще на один шаг
{
Pw+= StartPowerStep;  // увеличение яркости
 analogWrite (E1, Pw);   // На выводе ENABLE управляющий сигнал с новой яркостью
StartTimer=millis();  // Начало нового шага
 }  
 }
if (digitalRead(button_pin) == HIGH) {
if (Pw<255)   // Увеличиваем яркость до тех пор, пока не достигнем максимума
if ((millis()-StartTimer)>= StartTimeStep)  // Проверяем, сколько прошло с последнего изменения яркости
// если больше, чем заданный интервал – увеличим яркость еще на один шаг
{
Pw+= StartPowerStep;  // увеличение яркости
 analogWrite (E1, Pw);   // На выводе ENABLE управляющий сигнал с новой яркостью
StartTimer=millis();  // Начало нового шага 
}
}
else
{
    
if (Pw>150)   // Уменьшаем яркость до тех пор, пока не достигнем заданого
if ((millis()-StartTimer)>= StartTimeStep)  // Проверяем, сколько прошло с последнего изменения яркости
// если меньше, чем заданный интервал – уменьшим яркость еще на один шаг
{
Pw-= StartPowerStep;  // Уменьшение яркости
 analogWrite (E1, Pw);   // На выводе ENABLE управляющий сигнал с новой яркостью
StartTimer=millis();  // Начало нового шага 
}
}
}
